import Volume
import openstack
import StorageManager


class OpenstackStorageManager(StorageManager.StorageManager):

    def __init__(self, cloud) -> None:
        super().__init__()
        self.openstack = openstack.connect(cloud=cloud)

    @staticmethod
    def os_volume_to_rc_volume(os_volume):
        return Volume.Volume(
            os_volume.id,
            os_volume.size,
            os_volume.is_bootable
        )

    def create(self, size, bootable):
        os_volume = self.openstack.block_storage.create_volume(size=size, bootable=bootable)

        return self.os_volume_to_rc_volume(os_volume)

    def get(self, id):
        os_volume = self.openstack.block_storage.get_volume(id)

        return self.os_volume_to_rc_volume(os_volume)

    def delete(self, id):
        print(self.openstack.block_storage.delete_volume(id))

    def list(self):
        volumes = []

        for os_volume in self.openstack.block_storage.volumes():
            volumes.append(self.os_volume_to_rc_volume(os_volume))

        return volumes

    def resize(self, id):
        pass
